#! /bin/csh -f
#
# unsmear angle and no smear of hadron shower
befor_owl.com 25-12 cc-bd-n100 5.16
befor_owl.com 33-17 cc-bd-n100 5.2
befor_owl.com 50-25 cc-bd-n100 3.03
cp  processfile.for xxx.F
sed 's/\/9876/\/-9876/' xxx.F > xx1.F
sed 's/c        call unsmear/         call unsmear/' xx1.F > xx2.F
sed 's/energy_sm/energy_sm/' xx2.F  > xx3.F
sed 's/RNORMX1/RNORMX/' xx3.F | sed 's/ranlux1/ranlux/' >  xx4.F
/bin/rm xxx.F xx1.F xx2.F xx3.F
make clean
make all
/bin/rm xx4.F
owl trk-25-12-cc-bd-n100.dat > xx-25-12-cc-bd-n100-nh-na.dat 
mv analysis-.hbook analysis-25-12-cc-bd-n100-nh-na.hbook
owl trk-33-17-cc-bd-n100.dat > xx-33-17-cc-bd-n100-nh-na.dat
mv analysis-.hbook analysis-33-17-cc-bd-n100-nh-na.hbook
owl trk-50-25-cc-bd-n100.dat > xx-50-25-cc-bd-n100-nh-na.dat 
mv analysis-.hbook analysis-50-25-cc-bd-n100-nh-na.hbook
#
# smear angle and no  smear of hadron shower
cp  processfile.for xxx.F
sed 's/\/9876/\/-9876/' xxx.F > xx1.F
sed 's/c        call unsmear/c        call unsmear/' xx1.F > xx2.F
sed 's/energy_sm/energy_sm/' xx2.F  > xx3.F
sed 's/RNORMX1/RNORMX/' xx3.F | sed 's/ranlux1/ranlux/' >  xx4.F
/bin/rm xxx.F xx1.F xx2.F xx3.F
make clean
make all
/bin/rm xx4.F
owl trk-25-12-cc-bd-n100.dat > xx-25-12-cc-bd-n100-nh-sa.dat 
mv analysis-.hbook analysis-25-12-cc-bd-n100-nh-sa.hbook
owl trk-33-17-cc-bd-n100.dat > xx-33-17-cc-bd-n100-nh-sa.dat
mv analysis-.hbook analysis-33-17-cc-bd-n100-nh-sa.hbook
owl trk-50-25-cc-bd-n100.dat > xx-50-25-cc-bd-n100-nh-sa.dat 
mv analysis-.hbook analysis-50-25-cc-bd-n100-nh-sa.hbook
#
# unsmear angle and smear of hadron shower
cp  processfile.for xxx.F
sed 's/\/9876/\/-9876/' xxx.F > xx1.F
sed 's/c        call unsmear/         call unsmear/' xx1.F > xx2.F
sed 's/energy_sm/energy_sm/' xx2.F  > xx3.F
sed 's/RNORMX1/RNORMX1/' xx3.F | sed 's/ranlux1/ranlux1/' >  xx4.F
/bin/rm xxx.F xx1.F xx2.F xx3.F
make clean
make all
/bin/rm xx4.F
owl trk-25-12-cc-bd-n100.dat > xx-25-12-cc-bd-n100-sh-na.dat 
mv analysis-.hbook analysis-25-12-cc-bd-n100-sh-na.hbook
owl trk-33-17-cc-bd-n100.dat > xx-33-17-cc-bd-n100-sh-na.dat
mv analysis-.hbook analysis-33-17-cc-bd-n100-sh-na.hbook
owl trk-50-25-cc-bd-n100.dat > xx-50-25-cc-bd-n100-sh-na.dat 
mv analysis-.hbook analysis-50-25-cc-bd-n100-sh-na.hbook
#
# smear angle and smear of hadron shower
cp  processfile.for xxx.F
sed 's/\/9876/\/-9876/' xxx.F > xx1.F
sed 's/c        call unsmear/c        call unsmear/' xx1.F > xx2.F
sed 's/energy_sm/energy_sm/' xx2.F  > xx3.F
sed 's/RNORMX1/RNORMX1/' xx3.F | sed 's/ranlux1/ranlux1/' >  xx4.F
/bin/rm xxx.F xx1.F xx2.F xx3.F
make clean
make all
/bin/rm xx4.F
owl trk-25-12-cc-bd-n100.dat > xx-25-12-cc-bd-n100-sh-sa.dat 
mv analysis-.hbook analysis-25-12-cc-bd-n100-sh-sa.hbook
owl trk-33-17-cc-bd-n100.dat > xx-33-17-cc-bd-n100-sh-sa.dat
mv analysis-.hbook analysis-33-17-cc-bd-n100-sh-sa.hbook
owl trk-50-25-cc-bd-n100.dat > xx-50-25-cc-bd-n100-sh-sa.dat 
mv analysis-.hbook analysis-50-25-cc-bd-n100-sh-sa.hbook
#
# smear angle and sum pulse heights for hadron shower
cp  processfile.for xxx.F
sed 's/\/9876/\/-9876/' xxx.F > xx1.F
sed 's/c        call unsmear/c        call unsmear/' xx1.F > xx2.F
sed 's/energy_sm/energy_ph/' xx2.F  > xx3.F
sed 's/RNORMX1/RNORMX1/' xx3.F | sed 's/ranlux1/ranlux1/' >  xx4.F
/bin/rm xxx.F xx1.F xx2.F xx3.F
make clean
make all
/bin/rm xx4.F
owl trk-25-12-cc-bd-n100.dat > xx-25-12-cc-bd-n100-ph-sa.dat 
mv analysis-.hbook analysis-25-12-cc-bd-n100-ph-sa.hbook
owl trk-33-17-cc-bd-n100.dat > xx-33-17-cc-bd-n100-ph-sa.dat
mv analysis-.hbook analysis-33-17-cc-bd-n100-ph-sa.hbook
owl trk-50-25-cc-bd-n100.dat > xx-50-25-cc-bd-n100-ph-sa.dat 
mv analysis-.hbook analysis-50-25-cc-bd-n100-ph-sa.hbook
#
#rm_trk_files.com 25-12 cc-bd-n100
#rm_trk_files.com 50-25 cc-bd-n100
#rm_trk_files.com 33-17 cc-bd-n100
# nice -15  make_hbook_100.com >& xx100.dat
