      real function qe_eff(dummy)
*
      include ?
*
      real dummy
      integer nbin 
      parameter(nbin=8)
      vector bin(nbin+1)
      vector ntot_qe(nbin)
      vector ntot_pas(nbin)
      vector ntot_pas_qe(nbin)
      vector ntot_qe_al(1)
      vector ntot_pas_al(1)
      vector ntot_pas_qe_al(1)
      integer iev
      data iev/0/
c
c ************88
c
      bin(1)=0
      bin(2)=0.75
      bin(3)=1.0
      bin(4)=2.0
      bin(5)=3.0
      bin(6)=4.0
      bin(7)=5.0
      bin(8)=10.0
      bin(9)=100.0
      iev=iev+1
      if(iev.eq.1)then
        ntot_qe_al(1)=0
        ntot_pas_al(1)=0
        ntot_pas_qe_al(1)=0
        do i=1,nbin
          ntot_qe(i)=0.0
          ntot_pas(i)=0.0
          ntot_pas_qe(i)=0.0
        enddo
      endif
      ibin=0
      do i=1,nbin
        if(enu.ge.bin(i).and.enu.lt.bin(i+1))then
          ibin=i
          goto 500
        endif
c       if(i.eq.nbin.and.iev.le.30)write(6,100)enu,bin(i),bin(i+1)
100     format('  enu=',f10.4,2i4)
      enddo
500   continue
      if(cc*channel.eq.1.0.and.fidvtx.eq.1.and.nprong.ne.0)then
        ntot_qe(ibin)=ntot_qe(ibin)+1
        ntot_qe_al(1)=ntot_qe_al(1)+1
      endif
      pas_qe=qe_cuts_ad(0.0)
      if(pas_qe.eq.1.0)then
        ntot_pas(ibin)=ntot_pas(ibin)+1
        ntot_pas_al(1)=ntot_pas_al(1)+1
      endif
      if(pas_qe.eq.1.0.and.cc*channel.eq.1.)then
        ntot_pas_qe(ibin)=ntot_pas_qe(ibin)+1
        ntot_pas_qe_al(1)=ntot_pas_qe_al(1)+1
      endif
c     if(iev.le.500)write(6,300)iev,ibin,enu,cc*channel
c    +,ntot_pas(ibin),ntot_pas_qe(ibin), ntot_qe(ibin)
300   format(' iev,ibin,enu=',2i5,f8.2,f4.1,3i5)
      return
      end
      real function qe_cuts_ad(dummy)
*
      include ?
*
      real dummy
c trk= 1 means nprong can be 1 or 2
c trk(2) = 2 means nprong must be 2
      integer ntrk
      real q2low
      real q2hig
      real delx
      real ppert
      real hit
c
c ************
c
      qe_cuts_ad=0.0
      if(fidvtx.eq.1.and.muon.eq.1)then
c 0 to 0.5 GeV
        q2low = 0.0
        q2hig = 0.5
        ntrk = 1.0
        delx = 2.0
        ppert = 4.0
        hit = 0.0
        if(.true.
     +    .and.q2qe.gt.q2low
     +    .and.q2qe.le.q2hig
     +    .and.nprong.ge.ntrk
     +    .and.abs(Q2qe-twomnu)/q2_err.le.delx
     +    .and.ptrec/pt_err.le.ppert
     +    .and.hitsplan.gt.hit
     +    .and..true.)qe_cuts_ad=1.
c 0.5 to 1.0
        q2low = 0.5
        q2hig = 1.0
        ntrk = 1.0
        delx = 2.0
        ppert = 4.0
        hit = 0.0
        if(.true.
     +    .and.q2qe.gt.q2low
     +    .and.q2qe.le.q2hig
     +    .and.nprong.ge.ntrk
     +    .and.abs(Q2qe-twomnu)/q2_err.le.delx
     +    .and.ptrec/pt_err.le.ppert
     +    .and.hitsplan.gt.hit
     +    .and..true.)qe_cuts_ad=1.
c 1.0 to 2.0
        q2low = 1.0
        q2hig = 2.0
        ntrk = 2.0
        delx = 2.5
        ppert = 3.0
        hit = .0
        if(.true.
     +    .and.q2qe.gt.q2low
     +    .and.q2qe.le.q2hig
     +    .and.nprong.ge.ntrk
     +    .and.abs(Q2qe-twomnu)/q2_err.le.delx
     +    .and.ptrec/pt_err.le.ppert
     +    .and.hitsplan.gt.hit
     +    .and..true.)qe_cuts_ad=1.
c 2.0 to 3.0
        q2low = 2.0
        q2hig = 3.0
        ntrk = 2.0
        delx = 2.5
        ppert = 3.0
        hit = .0
        if(.true.
     +    .and.q2qe.gt.q2low
     +    .and.q2qe.le.q2hig
     +    .and.nprong.ge.ntrk
     +    .and.abs(Q2qe-twomnu)/q2_err.le.delx
     +    .and.ptrec/pt_err.le.ppert
     +    .and.hitsplan.gt.hit
     +    .and..true.)qe_cuts_ad=1.
c 3.0 to 10.0
        q2low = 3.0
        q2hig = 10.0
        ntrk = 2.0
        delx = 3.0
        ppert = 3.0
        hit = .0
        if(.true.
     +    .and.q2qe.gt.q2low
     +    .and.q2qe.le.q2hig
     +    .and.nprong.ge.ntrk
     +    .and.abs(Q2qe-twomnu)/q2_err.le.delx
     +    .and.ptrec/pt_err.le.ppert
     +    .and.hitsplan.gt.hit
     +    .and..true.)qe_cuts_ad=1.
      endif
      return
      end
