       subroutine ProcessFile(FromTracker)

#include "ntuple.inc"
#include "vertexNtuple.inc"
#include "fitterNtuple.inc"
#include "vector.inc"
#include "dEdxData.inc"
c#include "moduleData.inc"
C
c hb variables
#include "hb_common.inc"
      data smearhad_c/0.04/
      data smearhad_e/0.18/
      data smearhad_range/0.05/
      data smearmu_range/0.05/ 
      data smearmu_range_minos/0.05/ ! range= 286 layers*.031GeV/layer = 9
      data smearmu_mag/0.12/ 
      data smearhad_c_err/0.04/
      data smearhad_e_err/0.18/
      data smearhad_range_err/0.05/
      data smearmu_range_err/0.05/ 
      data smearmu_mag_err/0.12/ 
c
      integer  irange_trk_max
      real    range_max
c
c hb stuff
      integer nhit_tk(3),nhit_tot(3)
      integer ntot_hit
      real ener_tk(3),ener_tot(3)
      real p4mus(4), p4mu(4),pnus(4),p4hads(4)
      real phi_mu_rec,phi_pro_rec,d_phi_rec
      real range_mu_mx
c     data range_mu_mx/350.0/ ! range for a muon
      data range_mu_mx/150.0/ ! range for a muon
      real range_mu_mx_with_p 
c      data range_mu_mx_with_p/300.0/
       data range_mu_mx_with_p/80.0/
      integer iPtsSumEnd / 8/ ! number to sum for range
      real range_end(MAXNTRK)
      real edep_end(MAXNTRK)
      integer ibeg_trk_eve,iend_trk_eve
c ok thats it
      INTEGER iErr, LNBLNK, iCyc, nRmEvents, nRmCalor
      INTEGER nRmVtx, nRmCoord,EventNtupleId, VtxNtupleId
      INTEGER HitsNtupleId,DigNtupleId,CalNtupleId
      INTEGER iStrip, iMod, iRmEvent, idig, iAbs, iMat, i
      logical FromTracker,EventFilter
      real eloss_mod(5),totalen,dir(3),veclength,muon_angle
      real NucleonMass,MuonMass,Pmus,Pmu,pmu_true,pmu_true1 ! pmu_true1 uses truth 1
      real RECONSTRUCT_MUON
      real TrackAssociatedScint,TotalScintHit
      real Q2qe,Q2rec,xrec,eneutral,xv,yv,zv,maxRange,yrec
      real USHcalU, USHcalD, USEcalU, USEcalD
      real CentralU, CentralD
      real DSEcalU, DSEcalD, DSHcalU, DSHcalD
      real muon_angle_true,proton_angle_true
      integer ReconArray(5) ! ordering from recon
      integer reconList(5) ! reordered, 1=muon, 2=proton, 3=pion etc.
      integer hit_hash(180,65)
      character*4 mech
      real NtupleArray(46)
      data NucleonMass /0.939565/
      data  MuonMass / 0.105658/
      real err_neg ! if some quanity is - we replace it by this number
      data err_neg/0.00001/
      real dir_mu(3),dir_prot(3)
c
c ***********************
c
      nwrt = 9876
      CALL HNOENT(10001,nRmEvents) ! number of events histogram
      CALL HNOENT(10002,nRmHits) ! number of hitshistogram
      CALL HNOENT(10003,nRmDigHits) ! number of dig hits
      CALL HNOENT(10009,nRmCalor) ! number of Calor
      CALL HNOENT(10898,nRmVtx)
      CALL HNOENT(10899,nRmCoord)
      EventNtupleId = 10001
      HitsNtupleId = 10002
      DigNtupleId = 10003
      CalNtupleId = 10009
      VtxNtupleId = 10898
C
C Hardcode (Oh god no!) the module boundaries in Z
c right now not used
C

      USHcalU =  -211.75000 
      USHcalD =  -183.85001  
      USEcalU =  -183.85001  
      USEcalD = -138.25000    
      CentralU =-138.25000    
      CentralD = 89.75000   
      DSEcalU = 89.75000   
      DSEcalD = 127.75000  
      DSHcalU = 127.75000  
      DSHcalD =  211.75000
c gives the number for the ntuple 899 for the current
c event in EventNtupleId
      ibeg_trk_eve=1
      iend_trk_eve=1
C
C Loop over events
C
      do i=1,nRmEvents

       CALL HGNT(EventNtupleId,i,iErr)
       CALL HGNT(HitsNtupleId,i,iErr)
       CALL HGNT(DigNtupleId,i,iErr)
       CALL HGNT(CalNtupleId,i,iErr)
c merge adajacent points 
       call merge_order
c      if(nev.le.nwrt)call wrt_dig 
c try to get imformation out of the dedx ntuple
c arrays are not filled so lets effective bypass this
c      if(nrecon.ne.0)then ! if this is not dummied out
       if(nrecon.gt.10000)then ! this should not be statisfied
        ibeg_trk_eve=iend_trk_eve
        ibeg_trk_eve=min(nRmCoord,ibeg_trk_eve)
        CALL HGNT(10899,ibeg_trk_eve,iErr)
        do while( fitevent.lt.nev)
          ibeg_trk_eve=ibeg_trk_eve+1
          ibeg_trk_eve=min(nRmCoord,ibeg_trk_eve)
          CALL HGNT(10899,ibeg_trk_eve,iErr)
        enddo
        iend_trk_eve=ibeg_trk_eve+nrecon-1 
c now calculate some stuff
        do 951 jTrk=ibeg_trk_eve,iend_trk_eve
          CALL HGNT(10899,jtrk,iErr)
          iTrack=jTrk-ibeg_trk_eve+1
c          range(iTrack)=0
          edep(iTrack)=0
          range_end(iTrack)=0
          edep_end(iTrack)=0
          do 952  idEdxPts=1,ndEdxPts
c            range(iTrack)=range(iTrack)+xStop(idEdxPts)
            edep(iTrack)=edep(iTrack)+dE(idEdxPts)
            if(ndEdxPts-idEdxPts.le.iPtsSumEnd.or.ndEdxPts.le.iPtsSumEnd)then
              range_end(iTrack)=range_end(iTrack)+xStop(idEdxPts)
              edep_end(iTrack)=edep_end(iTrack)+dE(idEdxPts)
            endif
952       continue
          if(nev.ne.fitevent)then
            write(6,565)iTrack,nev,fitevent,nrecon
565         format("Caution, trk pntr, nev, fitevent, nrecon = ",4i4)
          endif
          if(nev.le.nwrt)then
            write (6,960)ndEdxPts,range(iTrack),edep(iTrack)
     +       ,range_end(iTrack),edep_end(iTrack)
960         format(" n,range,edep,r_end,e_end=",I5,4f10.4)             
            write(6,961)
961         format
     +      ("      icoor    dE      sLen     dEdx    dStop      xStop")
            do 954  idEdxPts=1,ndEdxPts
              write(6,962)idEdxPts,dE(idEdxPts),sLength(idEdxPts)
     +           ,dEdxSample(idEdxPts),dStop(idEdxPts),xStop(idEdxPts)
962           format(" ",i10, 5f10.4)
954         continue
          endif
951     continue
       endif
c end of attempt to get information out of dedx ntuple
C
C Apply event filter (essentially generated vertex fiducial cut)
c Right now it is aways true
C
       if (eventfilter()) then
C
C Initialise Ntuple array to whatever we can
C
        NtupleArray(1) = nrun*1.
        NtupleArray(2) = nev*1.
        if (nt_cc) then
         NtupleArray(3) = 1.
        else
         NtupleArray(3) = 0.
        endif
        NtupleArray(4) = nt_idcode*1.
        NtupleArray(5) = 0
        NtupleArray(6) = nt_initialQ
        NtupleArray(7) = 0
        NtupleArray(8) = 0
        NtupleArray(9) = 0
        NtupleArray(10) = 0
        NtupleArray(11) = nt_pneut(4)
        NtupleArray(12) = nt_x
        NtupleArray(13) = -nt_qsq
        NtupleArray(14) = -1.
        NtupleArray(15) = -1.
        NtupleArray(16) = -1.
        NtupleArray(17) = 0.0
        NtupleArray(18) = 0.0
        NtupleArray(19) = -999.
        NtupleArray(20) = -1.
        NtupleArray(21) = -1.
        NtupleArray(22) = -1.
        NtupleArray(23) = -1.
        NtupleArray(24) = -1.
        NtupleArray(25) = -1.
        NtupleArray(26) = -1.
        NtupleArray(27) = -1.
        NtupleArray(28) = -1.
        NtupleArray(29) = -1.
        NtupleArray(30) = -1.
        NtupleArray(31) = -1.
        NtupleArray(32) = -1.
        NtupleArray(33) = -1.
        NtupleArray(34) = 9999.0 ! pt error large if not calculated
        NtupleArray(35) = -1.
        NtupleArray(36) = -1.
        NtupleArray(37) = -1.
        NtupleArray(38) = -1.
        NtupleArray(39) = -1.
        NtupleArray(40) = -1.
        NtupleArray(41) = -1.
        NtupleArray(42) = -1.
        NtupleArray(43) = nt_w
        NtupleArray(44) = 0.0
        NtupleArray(45) = 0.0
        NtupleArray(46) = 0.0
c for writing to file 30 for resolution smearing
        i_acc   = -1  ! i_acc = 1 means variable get computed
        iana_channel=-1 ! channel event analyzed to be
        EnuQE = -1 ! 
        Q2qe  = -1
c
c request for Jorge Morfin get
c proton energy, muon energy and angle between proton and muon
        if(NtupleArray(3)*NtupleArray(4).eq.1.0)then
c         get the muon
          do j=1,ntruth
            if (ntmoth(j).eq.0) then ! particle is a primary
              if (nptrue(j).eq.13) then ! particle is a muon
                 MCmu = j
              endif
            endif
          enddo
C 
          if (MCmu.gt.0) then
            p_mu = sqrt(pxtrue(MCmu)**2+pytrue(MCmu)**2+pztrue(MCmu)**2)
            if(p_mu.ne.0)then
              dir_mu(1) = pxtrue(MCmu)/p_mu
              dir_mu(2) = pytrue(MCmu)/p_mu
              dir_mu(3) = pztrue(MCmu)/p_mu
            endif
          endif
c get the proton
          do j=1,ntruth
            if (ntmoth(j).eq.0) then ! particle is a primary
              if (nptrue(j).eq.2212) then ! particle is a proton
                 MCprot = j
              endif
            endif
          enddo
C 
          if (MCprot.gt.0) then
            p_prot 
     +      =sqrt(pxtrue(MCprot)**2+pytrue(MCprot)**2+pztrue(MCprot)**2)
            if(p_prot.ne.0)then
              dir_prot(1) = pxtrue(MCprot)/p_prot
              dir_prot(2) = pytrue(MCprot)/p_prot
              dir_prot(3) = pztrue(MCprot)/p_prot
            endif
          endif
          if(p_mu*p_prot.ne.0)then
            NtupleArray(38) = p_mu
            NtupleArray(39) = p_prot
            cross_mu_p=dir_mu(1)*dir_prot(1)+dir_mu(2)*dir_prot(2)
     +                                      +dir_mu(3)*dir_prot(3)
            NtupleArray(40) = acos(cross_mu_p)*180./3.141592654
          endif
        endif
c determine if there is an truth escaping muon
c       muon_truth_escape is an truth escaping muon
        muon_truth_escape=0
        do j=1,ntruth
C   check to determine  muon is an primary with escaping energy
        if (ntmoth(j).eq.0.and.nptrue(j).eq.13.and.etrueex(j).gt.0.0001)then
          muon_truth_escape = j
            NtupleArray(41) = etrueex(j)
          endif
        enddo
c
c end of Jorge Morfin's section
C
C Cut 1 - more than 1 reconstructed track?
C
c !!!! first cut in code - requires reconstructed track
       if(nev.le.nwrt)write(6,432)
432    format(' ')
       if(nev.le.nwrt.and.nrecon.eq.0)write(6,433)nev,i,nrecon
433    format(' nev =',i4,' i =',i4,' nrecon = ',i3)
c unsmear the angles, if commented out smearing
c        call unsmear_recon_dir
        if (nrecon.gt.0) then
          
C
C Find the particles connected to the primary reconstructed
C vertex, nmother = total mothers, nmothch = charged mothers
C
         nmother=0
         nmothch=0
         do j=1,ntruth
          if (ntmoth(j).eq.0)then
            nmother=nmother+1
            id=nptrue(j)
            if(id.ne.111.and.id.ne.2112)then
              nmothch=nmothch+1
            endif
          endif
         enddo
         NtupleArray(29)=1.0*nmother
         NtupleArray(31)=1.0*nmothch
         do j=1,5
          ReconArray(j) = 0
          reconList(j) = 0 
         enddo

         NPrim = 0
c if only one track there is no vertex
c so we call the only track associated with the vertex
         if(nrecon.eq.1)then
           NPrim=1
           ReconArray(1)=1
         else
          do j=1,nrecon
c          if (ntmoth(trk(j)).eq.0.and.iptrk(j).ne.22)then ! don't do photons
           if (istartv(j).eq.1.and.iptrk(j).ne.22)then ! don't do photons
            NPrim = NPrim+1
            ReconArray(NPrim)=j
           endif
          enddo
         endif
         NtupleArray(8) = NPrim
C
C Fiducial cut on the reconstructed vertex
C
         xv = startpos(1,ReconArray(1))
         yv = startpos(2,ReconArray(1))
         zv = startpos(3,ReconArray(1))
c vertex cut is a track cut
         if (sqrt(xv**2+yv**2).lt.80.0
c    +       .and.zv.lt.39.75.and.zv.gt.-128.25
     +       )NtupleArray(7) = 1. ! FidVtx

         if(nev.le.nwrt)write(6,436)nev,i,nrecon,nprim,NtupleArray(7)
436      format(' nev =',i4,' i =',i4,' nrecon = ',i3,' nprim =',i1
     +   ,' vertex = ',f3.1)
         if(nev.le.nwrt)call wrt_range 
c        call klug_range 
c        call fill_pid
c !!!! 2d cut requires a vertex 
         if(NtupleArray(7).eq.1.)then 
c !!!! 3d cut requires atleast primary
          if (NPrim.ge.1)then
C
C Find the muon
C Long selection for the muon
c Jmuon points back to ReconArray(j)
c while Imuon = ReconArray(Jmuon)
c No muon if Jmuon=0
           Jmuon=0
           Imuon=0
C If this particle gets into MINOS then it's a muon
           do j=1,Nprim
            do k=1,nminos
             if (trk(ReconArray(j)).eq.ntminos(k)) then
              JMuon = j
              NtupleArray(42) = 1.0*j
             endif
            enddo
           enddo
c *************************************
c          if jmuon=0 still haven't found the muon
c if range > range_mu_mx and it is non interacting with no escaping energy 
c in the inner detector it is a muon
           if (Jmuon.eq.0) then
            irange_trk_max=0 
            range_max=0
            do j=1,Nprim
             j_recon=ReconArray(j)
             if(range_max.le.range(j_recon).and.ishower(j_recon).eq.0
     +          .and.etrueex(trk(j_recon)).le.0.001)then
              range_max=range(j_recon)
              irange_trk_max=j
             endif
            enddo
            if(range_max.ge.range_mu_mx)Jmuon=irange_trk_max
c go lower if there is one track
c if there are two tracks we will have to decide which one is the muon
            if(range_max.ge.range_mu_mx_with_p.and.nprim.eq.1)
     +          Jmuon=irange_trk_max
           endif
c if one vertex track with range > range_mu_mx_with_p we accept the event
c make the muon the one with the smallest dedx/range
c we don't have dedx right now so comment this out, effectively comment this out
           if (Jmuon.eq.0.and.Nprim.eq.2 
     +       .and.range_max.ge.range_mu_mx_with_p) then
c          if (Jmuon.eq.999999.and.Nprim.eq.2
c    +       .and.range_max.ge.range_mu_mx_with_p) then ! this is not satisified
             jdedx_range_max=0 
             jdedx_range_min=0
             dedx_range_max=0
             dedx_range_min=999999.0
c if ntot_dedx_pass.ge.1 one track with a long dedx, but it may not be the muon
c particle must not interact or escape
             do j=1,Nprim
              dedx_range=edep(ReconArray(j))/range(ReconArray(j))
              if(dedx_range.gt.dedx_range_max
     +            .and.ishower(j).eq.0)then
               dedx_range_max=dedx_range
               jdedx_range_max=j
              endif
              if(dedx_range.lt.dedx_range_min
     +            .and.ishower(j).eq.0)then
               dedx_range_min=dedx_range
               jdedx_range_min=j
              endif
             enddo
             if(jdedx_range_min.ne.0)Jmuon=jdedx_range_min
             if(range_max.le.range_mu_mx.and.nprim.eq.2
     +          .and.NtupleArray(3)*NtupleArray(4).eq.1.0)
     +       write(6,950)nprim,jdedx_range_min,jdedx_range_max,jmuon
950          format(' nprim=',i4,' j_min =',i4,' j_max=',i4
     +       ,' jmuon = ',i4)
           endif
           if(Jmuon.ne.0)then
             Imuon=ReconArray(Jmuon)
             reconList(1) = ReconArray(Jmuon)
           endif
c fill in array for pion and proton
           if (NPrim.eq.2)then
             reconList(2) = ReconArray(3-JMuon)
           endif
           if(NPrim.gt.2)then
c find the number of particles for which we get a 
c chisquare
             num_chi=0
             j_chi_recon=0
             do j=1,NPrim
               j_recon=ReconArray(j)
               if(pidchi2(3,j_recon).ne.0
     +           .and.iMuon.ne.j_recon)then
                  j_chi_recon=j_recon 
                  num_chi=num_chi+1
               endif
             enddo
             chi2_pro_min=9999.0
             j_chi2_pro_min=0
             do j=1,NPrim
               j_recon=ReconArray(j)
               pid_chi_pro=pidchi2(3,j_recon)
               if(chi2_pro_min.ge.pid_chi_pro.and
     +           .iMuon.ne.j_recon.and.pid_chi_pro.ne.0)then
                 chi2_pro_min=pid_chi_pro
                 j_chi2_pro_min=j_recon
              endif
             enddo
             chi2_pi_min=9999.0
             j_chi2_pi_min=0
             do j=1,NPrim
               j_recon=ReconArray(j)
               pid_chi_pi=pidchi2(1,j_recon)
               if(chi2_pi_min.ge.pid_chi_pi.and
     +           .iMuon.ne.j_recon.and.pid_chi_pi.ne.0)then
                 chi2_pi_min=pid_chi_pi
                 j_chi2_pi_min=j_recon
              endif
             enddo
             e_ov_range_min=9999.0
             j_e_ov_range_min=0
             do j=1,NPrim
               j_recon=ReconArray(j)
               pid_chi_pro=pidchi2(3,j_recon)
               if(e_ov_range_min.ge.edep(j_recon)/range(j_recon).and
     +           .iMuon.ne.j_recon.and.pid_chi_pro.eq.0)then
                 e_ov_range_min=edep(j_recon)/range(j_recon)
                 j_e_ov_range_min=j_recon
              endif
             enddo
             e_ov_range_max=0
             j_e_ov_range_max=0
             do j=1,NPrim
               j_recon=ReconArray(j)
               pid_chi_pro=pidchi2(3,j_recon)
               if(e_ov_range_max.le.edep(j_recon)/range(j_recon).and
     +           .iMuon.ne.j_recon.and.pid_chi_pro.eq.0)then
                 e_ov_range_max=edep(j_recon)/range(j_recon)
                 j_e_ov_range_max=j_recon
               endif
             enddo
             if(nev.le.nwrt)then
               write(6,777)
777            format(' num_chi j_chi_recon, j_chi2_pro_min'
     +         ,' j_chi2_pi_min, j_e_ov_range_min, j_e_ov_range_max')
               write(6,778)num_chi,j_chi_recon,j_chi2_pro_min
     +          ,j_chi2_pi_min, j_e_ov_range_min, j_e_ov_range_max 
778            format(' ',i3,3i13,i15,i17)
             endif
c put in only identified particles
             if(num_chi.eq.1)then
               j_recon=j_chi_recon
               if(pidchi2(3,j_recon).lt.pidchi2(1,j_recon))then
                 reconList(2) = j_recon
               else
                 reconList(3) = j_recon
               endif
             endif
             if(num_chi.ge.2)then
               if(j_chi2_pro_min.ne.j_chi2_pi_min)then
                 reconList(2) = j_chi2_pro_min
                 reconList(3) = j_chi2_pi_min 
               else
                 if(pidchi2(3,j_chi2_pro_min)
     +            .lt.pidchi2(1,j_chi2_pi_min))then
                   reconList(2) = j_chi2_pro_min
                 else
                   reconList(3) = j_chi2_pi_min
                 endif
               endif
             endif
             if(reconList(2).eq.0)reconList(2)=j_e_ov_range_max
             if(reconList(3).eq.0)reconList(3)=j_e_ov_range_min
           endif 
c we have filled in reconList(1,2,3), we need to 
c fill in the rest with whatever is left, 
c Only what is in reconList(1,2,3) matters anyway
           if(NPrim.gt.3)then
             do 1010 k=4,NPrim
               do  1020 j=1,NPrim
                 do  1030 m=1,k-1
                   if(ReconList(m).eq.ReconArray(j))go to 1020
1030             continue
                 ReconList(k)=ReconArray(j)
1020           continue
1010         continue
           endif
           call hadron_energy_sm(reconList,nprim,e_hads,epros,e_pis
     +      ,w_had_rec,p4hads,ehad_tru,smearhad,smearpmom,itype,0)
           NtupleArray(45) = ehad_tru
           NtupleArray(46) = e_hads
           
c Fill out reconList with the rest of the pions
c pick out the largest energy track for the next

c write out some stuff
           if(nev.le.nwrt)then
             if(jmuon.ne.0)then
               write(6,434)nev,nprim,nt_pneut(4),-nt_qsq,
     +         nptrue(trk(imuon)),range(imuon)
434            format(' nev = ',i4,' nprim =',i1,' enu = ',f7.3
     +              ,' q2 = ',f6.3,' typ = ',i4,' range =',f8.2)
             else
               write(6,434)nev,nprim,nt_pneut(4),-nt_qsq
             endif
             call wrt_evt(Jmuon,reconList,e_hads,epros,e_pis
     +         ,w_had_rec,p4hads,ehad_tru,smearhad,itype)
           endif
c OK its written out
           if (Imuon.gt.0) NtupleArray(9) = 1. ! muon
c !!!! cut 4  on muon 
           if (Imuon.gt.0) then
            NtupleArray(36) = range(iMuon)
C Try some energy reconstruction
C
C Assume that the muon momentum can be measured to 10%
C Maybe parametrise energy vs range in a second step
C
            emus = RECONSTRUCT_MUON(trk(iMuon))
            NtupleArray(21) = petrue(trk(iMuon))
            NtupleArray(25) = emus
C
C Reconstruct muon angle from the first segment of the track
C
            dir(1) = startdir(1,Imuon)
            dir(2) = startdir(2,Imuon)
            dir(3) = startdir(3,Imuon)
            veclength = sqrt(dir(1)**2+dir(2)**2+dir(3)**2)
            if (veclength.gt.0) then
             muon_angle = startdir(3,Imuon)/veclength
             muon_angle = acos(muon_angle)*180./3.141592654
            endif
            NtupleArray(23) = muon_angle
C
C Reconstructed muon momentum
C
            Pmus = Sqrt(emus**2-MuonMass**2)
            p4mus(1) = Pmus*startdir(1,Imuon)/veclength
            p4mus(2) = Pmus*startdir(2,Imuon)/veclength
            p4mus(3) = Pmus*startdir(3,Imuon)/veclength
            p4mus(4)=emus
            phi_mu_rec=atan(p4mus(2)/p4mus(1))
            pt_mu_err=smear_muon(emus)*sqrt(p4mus(1)**2+p4mus(2)**2)
c **********************!!!!!!!!!! check thies statement ************
            if(smear_muon(emus).eq.0)pt_mu_err=1.0
C
C The muon always appears in the MC list as particle 1 for CC events
C
            dir(1) = pxtrue(1)
            dir(2) = pytrue(1)
            dir(3) = pztrue(1)
            pmu_true1 = sqrt(dir(1)**2+dir(2)**2+dir(3)**2)
            if (pmu_true1.gt.0) then
             muon_angle_true = dir(3)/pmu_true1
             muon_angle_true = acos(muon_angle_true)*180./3.141592654
            endif
            NtupleArray(27) = muon_angle_True
            if(nev.le.nwrt)then 
              write(6,678)nev,Imuon,trk(Imuon),nt_qsq,pmu_true1
     +        ,NtupleArray(27),NtupleArray(23)
678           format(' nev=',i4,', imu=',2i3,' q2 = ',f8.4
     +        ,' pmu= ',f8.4,' true muon angle ='
     +        ,f8.4,' rec muon angle =',f8.4)
            endif
C
C true muon variables, but use Imuon for now
C
            dir(1) = pxtrue(trk(Imuon))
            dir(2) = pytrue(trk(Imuon))
            dir(3) = pztrue(trk(Imuon))
            pmu_true = sqrt(dir(1)**2+dir(2)**2+dir(3)**2)
            Pmu = Sqrt(petrue(trk(Imuon))**2-MuonMass**2)
            p4mu(1) = Pmu*dir(1)/pmu_true
            p4mu(2) = Pmu*dir(2)/pmu_true
            p4mu(3) = Pmu*dir(3)/pmu_true
            p4mu(4) = petrue(trk(Imuon))
            Pmus = Sqrt(emus**2-MuonMass**2)
            EnuQe = ((NucleonMass*emus)-(MuonMass**2)/2.)/
     +      (NucleonMass - emus + Pmus*cos(muon_angle*3.141592654/180.))
            Q2qe=4*EnuQe*emus*(sin(muon_angle*3.141592654/180./2.))**2
            EnuRec = emus+e_hads-NucleonMass
            Q2Rec=4*EnuRec*emus*(sin(muon_angle*3.141592654/180./2.))**2
            yRec = (EnuRec-emus)/enurec
            xRec = Q2Rec/(2*NucleonMass*EnuQe*Yrec)
            wRec2 =2.0*NucleonMass*e_hads-NucleonMass**2-Q2Rec
            if(wRec2.ge.0.0)then
              wRec=sqrt(wRec2)
            else
              wRec=-sqrt(-wRec2)
            endif
            q2_nu=2.0*NucleonMass*(e_hads-NucleonMass)
            if(q2_nu.le.0)q2_nu=err_neg ! make it + if it goes < 0 
            NtupleArray(32)=q2_nu
c error for  Q2qe-2mnu, assume 0.19*Q2qe for Q2qe right now
            twomnu_err = 2.*NucleonMass*smearhad
c           q2_err = 0.19*Q2qe
            q2_err_ang=2.0*EnuQe**2*sin(muon_angle*3.141592654/180.)*0.005
            q2_err_emu=Q2qe*(1.0+EnuQe/emus)*smear_muon(emus)/emus
            q2_err=sqrt(q2_err_ang**2+q2_err_emu**2)
            q2_diff_err=sqrt(twomnu_err**2+q2_err**2)
            NtupleArray(35)=q2_diff_err
c the nex set of lines needs to be checked since changing to >1 hadrons
c           NtupleArray(33)=abs(phi_mu_rec-phi_pro_rec)*180./3.141592654
            NtupleArray(33)=0. ! zero out delphi
c Calculate ptrec  only if p4hads is is calculated
c p4hads is not calculated if nprim=1 or nprim > 3 or 2 interacting hadrons
            if(itype.ge.2)then
              ptrec=sqrt((p4mus(1)+p4hads(1))**2+(p4mus(2)+p4hads(2))**2)
              NtupleArray(22)=ptrec
              phtotal=sqrt(p4hads(1)**2+p4hads(2)**2+p4hads(3)**2)
              pt_had_err=smearpmom*sqrt(p4hads(1)**2+p4hads(2)**2)/phtotal
              pt_err=sqrt(pt_mu_err**2+pt_had_err**2)
              NtupleArray(34) = pt_err
            endif
c The next line is not exactly correct, mu could me misidentified
c also it should really be the 2 hadrons, so it needs to be changed.
            pttru=sqrt((p4mu(1)+nt_phtot(1))**2+(p4mu(2)+nt_phtot(2))**2)
            NtupleArray(30)=pttru 
            call dis_par(imuon,nhit_tk,nhit_tot,ener_tk,ener_tot)
            NtupleArray(5) = wRec
            NtupleArray(10) = itype*1.0
            NtupleArray(14) = EnuQE
            NtupleArray(15) = XRec
            NtupleArray(16) = Q2qe
            NtupleArray(17) = iptrk(Imuon)*1.
            if(ReconList(2).ne.0)NtupleArray(18)=iptrk(ReconList(2))*1.
            NtupleArray(19) = EnuRec
            NtupleArray(24) = Q2rec
            NtupleArray(20) =(nhit_tk(1)*1.+nhit_tk(2)*1.+nhit_tk(3)*1.)
     +                  /(nhit_tot(1)*1.+nhit_tot(2)*1.+nhit_tot(3)*1.)
            NtupleArray(26) = (ener_tk(1)+ener_tk(2)+ener_tk(3))
     +                        /(ener_tot(1)+ener_tot(2)+ener_tot(3))
            NtupleArray(28) = w_had_rec
            if(ReconList(2).ne.0) NtupleArray(37) = range(ReconList(2))
            if(ReconList(3).ne.0)NtupleArray(44)=iptrk(ReconList(3))*1.
c           this states the variable for the write(30, are calculated
            i_acc=1
            if(nev.le.nwrt)then
              q2dif=(Q2qe-q2_nu)/q2_diff_err
              write(6,567)nev,emus,pmus,EnuQe,q2qe,enurec,q2rec
567           format(' nev',i4,' emus =',f7.4,' pmus =',f7.4,' EnuQe ='
     +           ,f7.4,' q2qe =',f7.4,' enurec =',f7.4,' q2rec =',f7.4)
              write(6,568)yRec,xrec,wrec,q2_nu,q2_diff_err,q2dif
568           format(' yRec =',f7.4,' xrec =',f7.4,' wrec =',f7.4
     +               ,' q2_nu =',f7.4,' q2_diff_err =',f7.4,' q2dif =',f6.3)
              write(6,569)ptrec,pttru,pt_err,ptrec/pt_err,pt_had_err
     +        ,pt_mu_err,smearhad,smearpmom
569           format(' ptrec=',f6.3,' pttru=',f6.3,' pt_err=',f6.3
     +        ,' pt/err=',f6.2,' pt_had_err=',f6.3,' pt_mu_err=',f6.3
     +        ,' smearhad=',f6.3,' smearpmom=',f6.3) 
              write(6,877)nhit_tk,nhit_tot
877           format('  nhit_tk =',3i5,' nhit_tot =',3i6)
              write(6,878)ener_tk,ener_tot
878           format(' ener_tk =',3f8.1,' ener_tot =',3f8.1)
            endif
            if (.true.
     +          .and..false.
     +          .and.nt_cc
c    +          .and.nt_idcode.eq.1
c    +          .and.nt_idcode.ne.1
c    +          .and.Imuon.ne.0
c    +          .and.NtupleArray(7).eq.1 ! vertex cut
c    +          .and.-nt_qsq.gt.3 
c    +          .and.NPrim.le.2 
c    +          .and.NtupleArray(20).gt.0.85 ! hit variable
     +          .and..true.)
     +          write(6,306)nev,NtupleArray(20),NtupleArray(26)
     +                ,nt_idcode,-nt_qsq,NPrim,nrecon
306             format(' nev = ',i4,' %hists =',f5.2,' %ener =',f5.2
     +           ,' type=',i2,' q2 =',f5.2,' NPrim = ',i1,' ntrak =',i2)
           endif ! Imuon.gt.0 cut
          endif ! NPrim.ge.1 cut
         endif ! vertex cut
        endif !  nrecon.gt.0 cut
       endif ! eventfilter clause
       if (EnuQE.gt.-100.0.and.EnuQE.lt.1000.0.and.
     +      Q2qe.gt.-100.0.and.Q2qe.lt.1000.) then
          write(30,978)i_acc,nt_idcode,iana_channel
     +    ,nt_pneut(4),EnuQE,-nt_qsq,Q2qe
978      format(' ',3i4,4f11.5)
         call hfn(30,NtupleArray)
       endif
      enddo     ! event loop
      return
      end
C
C Does any energy escape the detector which doesn't
C come from the muon?
C
      REAL FUNCTION RECONSTRUCT_MUON(TrkPtr)
C
#include "ntuple.inc"
#include "vertexNtuple.inc"
#include "fitterNtuple.inc"
#include "vector.inc"
C
      external ranlux
      real rand
      integer TrkPtr
C
      CALL RNORMX(rand,1,ranlux)
      e_mu_true=petrue(TrkPtr)
      emus = e_mu_true*(1.+rand*smear_muon(e_mu_true))
C
      RECONSTRUCT_MUON = emus
      if(nev.le.nwrt)write(6,400)
     +  e_mu_true,rand,emus,smear_muon(e_mu_true)
400   format(' emus,ran,emus_smear,smear = ',4f10.4)
C
      RETURN
      END
c
      REAL FUNCTION smear_muon(emu) 
#include "hb_common.inc"
c
c ****************
c
      if(emu.le.1.0)then
         smear_muon=smearmu_range
      elseif (emu.gt.1.0.and.emu.le.10.0) then
         smear_muon=smearmu_range_minos
      else
         smear_muon=smearmu_mag
      endif 
      return
      end
C
      real Function TrackAssociatedScint(reconList,ntrk)
C
#include "ntuple.inc"
#include "vertexNtuple.inc"
#include "fitterNtuple.inc"
#include "vector.inc"
C
C Count the number of track associated scintillators hit for a given track
C
      integer hit_hash(180,65),reconList(5),ntrk
      integer k,l,pitrk,NumberHit,trkindex

      do k=1,180
       do l=1,65
        hit_hash(k,l) = 0
       enddo
      enddo
C
      NumberHit = 0
      do i=1,ntrk
C
C For now use "raw" hits and assume we've got them all
C
       pitrk = trk(reconList(i))
       do k=1,nhit
        if (nthit(k).eq.pitrk) then
         hit_hash(modhit(k),scinthit(k))=1
        endif
       enddo
      enddo
C
      NumberHit = 0
      do k=1,180
       do l=1,65
        if (hit_hash(k,l).gt.0) NumberHit=NumberHit+1
       enddo
      enddo
C
      TrackAssociatedScint=NumberHit*1.
      return
      end
C
      real Function TotalScintHit()
C 
#include "ntuple.inc"
#include "vertexNtuple.inc"
#include "fitterNtuple.inc"
#include "vector.inc"

C
      integer hit_hash(180,65)
      integer k,l,NumberHit
c
      do k=1,180
       do l=1,65
        hit_hash(k,l) = 0
       enddo
      enddo
 
      do i=1,nhit
       hit_hash(modhit(i),scinthit(i))=1 
      enddo
      
      NumberHit = 0
      do k=1,180
       do l=1,65
        if (hit_hash(k,l).gt.0) NumberHit=NumberHit+1
       enddo
      enddo

      TotalScintHit=NumberHit*1.
      return
      end

      subroutine wrt_evt(Jmuon,reconList,e_hads,epros,e_pis
     +         ,w_had_rec,p4hads,ehad_tru,smearhad,itype)

C
#include "ntuple.inc"
#include "vertexNtuple.inc"
#include "fitterNtuple.inc"
#include "vector.inc"
C
      real p4hads(4)
      integer JMuon,reconList(5)
c
c *****************
c
      write(6,100)nev,Jmuon,reconList
100   format('in wrt_evt, nev =',i4,' Jmuon=',i4,' reconList=',5i4)
      icc=0
      if (nt_cc) then
        icc = 1
      endif
      write(6,105)icc,nt_idcode,nt_initialQ,nt_w,nt_x,nt_y,nt_pneut
105   format(' cc =',i1,' idcode =',i1,' res typ =',i4,' w ='
     +,f8.4,' x =',f8.4,' y =',f8.4,' pneut =',4f9.5)
      write(6,110)nt_ptarg
110   format(' ptarg =',5f9.5)
      write(6,115)e_hads,epros,e_pis,ehad_tru,smearhad,itype
115   format(' e_hads =',f8.4,' epros = ',f8.3,' epis = ',f8.3
     +,' ehad_tru =',f8.5,' smearhad = ',f7.4,' itype =',i2)
      iw_had_ok=1 ! w_had_rec should be > m_p
      if(w_had_rec.le.0.9382.and.w_had_rec.ge.0.0001)iw_had_ok=0
      write(6,120)p4hads,w_had_rec,iw_had_ok
120   format(' p4hads =',4f9.3,' w_had_rec =',f7.4,' w_had_ok=',i1)
      do j=1,nrecon
        jshower=ishower(j)
        write(6,901)j,trk(j),iptrk(j),istartv(j)
     +  ,iendv(j),nrechit(j),pidchi2(1,j),pidchi2(3,j)
901      format(' j=',i3,' trk = ',i2,' iptrk = ',i4,' istartv =',i2
     +  ,' iendv =',i2,' nrechit =',i3,' chi2pi =' ,f8.3
     +  ,' chi2pro =',f7.3) 
        write(6,902)range(j),edep(j)/range(j)
     +  ,jshower,petrue(trk(j)),(startdir(it,j),it=1,3)
902     format( '  range=',f7.1,' edep/range=', f11.5
     +  ,' ishow=',i3,' ener_tru=',f8.3,' startdir=',3f8.4)
c       write(6,903)(startpos(k,j),k=1,3),(endpos(k,j),k=1,3)
903     format( '   startpos = ',3f10.4,' endpos = ',3f10.4)
c       write(6,904)(startdir(k,j),k=1,3),(enddir(k,j),k=1,3)
904     format( '   startdir = ',3f10.4,' enddir = ',3f10.4)
c       write(6,905)startmom(j), endmom(j), seedmom(j)
c    +             ,range(j),edep(j)
905     format('    startmom = ',f7.3,'  endmom = ',f7.3
     +  ,'  seedmom = ',f7.3,'  range = ',f8.3,'  edep = ' ,f7.3) 
      enddo
      do j=1,ntruth
        write(6,900)j,ntmoth(j),nptrue(j),petrue(j)
900     format('   j =',i4,' ntmoth =',i3
     +  ,' nptrue =',i4,' petrue = ',f9.4)
      enddo
      write(6,890)(nt_hadron(i),i=1,nt_nhadrons)
890   format(' vtx had =',12i5)
      write(6,910)
910   format(' ')
      RETURN
      END
      integer function ishower(jrecon)
c i=0 particle doesn't shower, =999 if passed jrecon=0
#include "ntuple.inc"
c p_int_min give the amount of energy that can be left
c and still classify it as a non interacting particle
      real p_int_min
      data p_int_min/0.02/
c
c ***************
c
      ishower=1
      if(jrecon.eq.0)then
        ishower=999
        return
      endif
c     if(etrueex(trk(jrecon)).gt.0.00001)return
      ndaug=0
      p_min=99999.
      p_max=0.
      itru_e_min=0
      itru_e_max=0
      do 10 itruth=1,ntruth
        if(ntmoth(itruth).eq.trk(jrecon)
     +    .and.nptrue(itruth).ne.13.and.nptrue(itruth).ne.-13)then
          ndaug=ndaug+1
          p_mom=sqrt(pxtrue(itruth)**2+pytrue(itruth)**2+pztrue(itruth)**2)
          if(p_min.gt.p_mom)then
            p_min=p_mom
            itru_e_min=itruth
          endif
          if(p_max.lt.p_mom)then
            p_max=p_mom
            itru_e_max=itruth
          endif
        endif
10    continue
c  be sure the daughter with the biggest pgy 
c  does not have daughters
      if(ndaug.eq.0)then
        ishower=0
        return
      endif
c particle has interaction with 1 or more 
c particles
      ndaug_e_max=0
      do 20 itruth=1,ntruth
        if(ntmoth(itruth).eq.itru_e_max)then
          ndaug_e_max=ndaug_e_max+1
        endif
20    continue
      if(ndaug_e_max.eq.0)then
        if(ndaug.le.1)ishower=0
        if(ndaug.eq.2.and.p_min.le.p_int_min)ishower=0
      endif
      return
      end
c 
      real function e_neutral(xdummy)
c i=0 particle doesn't shower
#include "ntuple.inc"
#include "vector.inc"
c ene_int_min give the amount of energy that can be left
      e_neutral=0
      do 10 ihadron=1,nt_nhadrons
        id=nt_hadron(ihadron)
        if(id.eq.111.or.id.eq.2112)e_neutral=e_neutral+nt_phadron(4,ihadron)
10    continue
      return
      end
c ****************************************************************
c Unsmearing everything
      subroutine  RNORMX1(rand,iset,ranlux)
c the routine doesn't seem to work so create this to keep 
c debugging      
      external ranlux
      real rand
      integer iset
      rand=0.0
      return
      end

      subroutine  ranlux1(rand,int)
c create the same number each time
      real rand
      integer int
      rand=0.0
      return
      end
      subroutine unsmear_recon_dir
c gives the recon directions the truth directions
c this is done to check the code and smearing
#include "ntuple.inc"
c
c ***************88
c
       do j=1,nrecon
         itr=trk(j)
         ptot=sqrt(pxtrue(itr)**2+pytrue(itr)**2+pztrue(itr)**2)
         startdir(1,j)=pxtrue(itr)/ptot
         startdir(2,j)=pytrue(itr)/ptot
         startdir(3,j)=pztrue(itr)/ptot
       enddo
       return
       end
