c This creates the file for dis_mor.F. It 
c orders the hits, merges adajacent hits,
c and puts them back into dighits so 
c dighits is modified 
      subroutine merge_order
      integer iwr
      data iwr/0/
      if(iwr.eq.1)call wrt_dig
      call order_dig
      if(iwr.eq.1)call wrt_dig
      call merge_same_hits
      if(iwr.eq.1)call wrt_dig
      call ave_dig
      if(iwr.eq.1)call wrt_dig
      return
      end 
      subroutine merge_same_hits
c note if 2 or more scintillators appear
c only the energy of 2 are summed
c Hits which hit the same scintillator are merged  
c 
C Digitised hits
C
#include "ntuple.inc"
      integer iwr_evt/ -9876/
c
      if(ndig.le.1)return
100   continue
      nsame=0
      do 400 idig=1,ndig-1
        if(moddig(idig).eq.moddig(idig+1).and.
     +  SCINTDIG(idig).eq.SCINTDIG(idig+1))then
          eobs(idig)=eobs(idig)+eobs(idig+1)
          tdig(idig+1)=-9999.0
          eobs(idig+1)=0
          nsame=nsame+1
        endif
400   continue
      call rem_excess_dig
      if(nsame.eq.0)go to 200
      go to 100
200   continue
      return
      end
      subroutine ave_dig
c energy weights adajacent hits. puts
c them into one hit and sets eobs=0 and tdig=-9999
c for the other hit.
C
C Digitised hits
C
#include "ntuple.inc"
c
c **********************8
c

      real pe_mev 
      data pe_mev/5.2/
      real xcess_noise/0.2/
      external ranlux
      real eobs_i,eobs_i1
      real exp_pe_i,exp_pe_i1
      real x_npe_i,x_npe_i1
      real xeobs_i, xeobs_i1
      real gran_i,gran_i1
      integer ierr_i,ierr_i1
      integer npe_i,npe_i1
      integer iwr_evt/-9876/
c
      if(ndig.le.1)return
      jdig=0
      do 400 idig=1,ndig
        if(idig.gt.jdig)then
          jdig=idig
          if(scintdig(idig+1)-scintdig(idig).eq.1)then
c count the number of consecutive hits
500         continue
            if(eobs(jdig+1).ne.0.and.moddig(idig).eq.moddig(jdig+1)
     +       .and.scintdig(jdig+1)-scintdig(idig).eq.jdig+1-idig)then
              jdig=jdig+1
              if(jdig.lt.ndig)go to 500
            endif
c Just 2 consecutvie hits energy weighted average hits
            if(jdig-idig.eq.1)then
              eobs_i=(float(eobs(idig))-0.5)/10.0
              eobs_i1=(float(eobs(idig+1))-0.5)/10.0
              exp_pe_i =pe_mev*(float(eobs(idig  ))-0.5)/10.0
              exp_pe_i1=pe_mev*(float(eobs(idig+1))-0.5)/10.0
              if(exp_pe_i.gt.0)then
                 call rnpssn(exp_pe_i ,npe_i ,ierr_i)
              else
                npe_i=0
              endif
              if(exp_pe_i1.gt.0)then
                call rnpssn(exp_pe_i1,npe_i1,ierr_i1)
              else
                npe_i1=0
              endif
              x_npe_i =float(npe_i)
              x_npe_i1=float(npe_i1)
              CALL RNORMX(gRan_i,1,ranlux)
              CALL RNORMX(gRan_i1,1,ranlux)
              xeobs_i=x_npe_i*(1.+gRan_i*xcess_noise)/pe_mev
              if(xeobs_i.le.0)xeobs_i=0
              xeobs_i1=x_npe_i1*(1.+gRan_i1*xcess_noise)/pe_mev
              if(xeobs_i1.le.0)xeobs_i1=0
              tdig(idig)=
     +        (xeobs_i*tdig(idig)+xeobs_i1*tdig(idig+1))
     +          /(xeobs_i+xeobs_i1)
               eobs(idig)=10.0*(xeobs_i+xeobs_i1)+1.0
               tdig(idig+1)=-9999.0
               eobs(idig+1)=0
              if(iwr_evt.gt.0)then
                write(6,505)eobs_i,eobs_i1
505             format(' eobs_i =',2f10.3)
                write(6,510)exp_pe_i,exp_pe_i1
510             format(' exp_pe_i =',2f10.3)
                write(6,515)npe_i,npe_i1
515             format(' npe_i =',2I5)
                write(6,520)x_npe_i,x_npe_i1
520             format(' x_npe_i =',2f12.3)
                write(6,530)xeobs_i,xeobs_i1,gRan_i,gRan_i1
530             format(' xeobs_i =',2f10.4,' gRan_i=',2f10.4)
                iwr_evt=iwr_evt-1
              endif
            endif
          endif
        endif
400   continue
      call rem_excess_dig
      return
      end
c
      subroutine rem_excess_dig
c remove excess dig hits.
C
C Digitised hits
C
#include "ntuple.inc"
c
c ******************************
c
      if(tdig(ndig).eq.-9999.0)ndig=ndig-1
      numdig=ndig
      do 400 idig=numdig,2,-1
          if(tdig(idig).eq.-9999.0)call rem_ind_dig(idig)
400   continue
      return
      end
      subroutine rem_ind_dig(idig)
C
C Digitised hits
C
#include "ntuple.inc"
c
c ******************************
c
      do 400 kdig=idig,ndig-1
        moddig(kdig)=moddig(kdig+1) 
        scintdig(kdig)=scintdig(kdig+1) 
        orientdig(kdig)=orientdig(kdig+1) 
        trkdig(1,kdig)=trkdig(1,kdig+1) 
        trkdig(2,kdig)=trkdig(2,kdig+1) 
        trkdig(3,kdig)=trkdig(3,kdig+1) 
        trkdig(4,kdig)=trkdig(4,kdig+1) 
        eobs(kdig)=eobs(kdig+1) 
        zdig(kdig)=zdig(kdig+1) 
        tdig(kdig)=tdig(kdig+1) 
400   continue
      ndig=ndig-1
      return
      end
      subroutine order_dig
c remove excess dig hits.
C
C Digitised hits
C
#include "ntuple.inc"
c
c ******************************
c
      integer mod_mult
      data mod_mult/300/
      nstart=1
      nend=ndig-1
100   continue
      iswitch=0
      do 400 idig=nstart,nend
        mod_sci=mod_mult*moddig(idig)+SCINTDIG(idig)           
        mod_sci1=mod_mult*moddig(idig+1)+SCINTDIG(idig+1)           
        if(mod_sci1.lt.mod_sci)then
          iswitch=iswitch+1
          if(iswitch.eq.1)nstart=idig
          call interchange_dig(idig)
          nend=idig
        endif
400   continue
      if(iswitch.ne.0)then
        if(nstart.gt.1)nstart=nstart-1
        if(nend.lt.ndig)nend=nend+1
        if(nend.eq.ndig)nend=ndig-1
        go to 100
      endif
      return
      end
      subroutine interchange_dig(kdig)
C
C Digitised hits
C
#include "ntuple.inc"
c
c ******************************
c
      real xx
c
      xx=moddig(kdig) 
      moddig(kdig)=moddig(kdig+1) 
      moddig(kdig+1)=xx
c
      xx=scintdig(kdig) 
      scintdig(kdig)=scintdig(kdig+1) 
      scintdig(kdig+1)=xx
c
      xx=orientdig(kdig) 
      orientdig(kdig)=orientdig(kdig+1) 
      orientdig(kdig+1)=xx
c
      xx=trkdig(1,kdig) 
      trkdig(1,kdig)=trkdig(1,kdig+1) 
      trkdig(1,kdig+1)=xx
c
      xx=trkdig(2,kdig) 
      trkdig(2,kdig)=trkdig(2,kdig+1) 
      trkdig(2,kdig+1)=xx
c
      xx=trkdig(3,kdig) 
      trkdig(3,kdig)=trkdig(3,kdig+1) 
      trkdig(3,kdig+1)=xx
c
      xx=trkdig(4,kdig) 
      trkdig(4,kdig)=trkdig(4,kdig+1) 
      trkdig(4,kdig+1)=xx
c
      xx=eobs(kdig) 
      eobs(kdig)=eobs(kdig+1) 
      eobs(kdig+1) =xx
c
      xx=zdig(kdig) 
      zdig(kdig)=zdig(kdig+1) 
      zdig(kdig+1) =xx
c
      xx=tdig(kdig) 
      tdig(kdig)=tdig(kdig+1) 
      tdig(kdig+1) =xx
c
400   continue
      return
      end
      subroutine wrt_dig
#include "ntuple.inc"
c
c ******************************
c
       write(6,380)nev
380    format(' in wrt_dig, nev =',i4)
       write(6,390)
390    format(' hit  module scin   uxv       z   '
     +  ,'  eobs  orien  trkdig')
       do 100 idig=1,ndig
         write(6,400)idig, MODDIG(idig),SCINTDIG(idig)
     +   ,TDIG(idig),zdig(idig),eobs(idig),orientdig(idig),trkdig(1,idig)
400      format(i4,2i5, 2f10.3,i6,i5,i9)
100    continue
       return
       end
