      program owl
      IMPLICIT NONE
#include "ntuple.inc"
C #include "vector.inc"
C #include "moduleData.inc"

      integer nwpawc, hpaw
      parameter (nwpawc = 5000000)
      common/pawc/hpaw(nwpawc)

      INTEGER nArgs, iargc, iErr, LNBLNK, iCyc, nRmEvents
      INTEGER iStrip, iMod, iRmEvent, idig, nPE, iAbs, iMat, i
      CHARACTER*132 fileName,DataFileName
      EXTERNAL ranlux
      REAL gausRand
      logical ok,hexist,FromTracker

      call hlimit(nwpawc)

      nArgs = iargc()

      IF (nArgs .LT. 1) THEN
          PRINT *, 'owl: No input file specified - stopping'
          STOP
      ENDIF

      CALL GETARG(1,fileName)
C
C Loop over the number of input files
C
      inquire(file=fileName(1:LNBLNK(fileName)),exist=ok)
      if (.not.ok) then
       PRINT *,'owl: Error opening file ',fileName(1:LNBLNK(fileName))
       STOP
      endif

C
C Define histograms in procInit...
C
      call procInit

      open(unit=40,file=fileName(1:LNBLNK(fileName)),status='unknown')

10    read(40,*,end=100) DataFileName
      print *,'=============================='
      print *,'DataFileName : ',DataFileName
C
C Read in the ntuples from the datafiles
C
      CALL HROPEN(50,'DATA',DataFileName(1:LNBLNK(DataFileName)),
     +                   'X',1024,iErr)
      iCyc = 99999
      call hrin(2,iCyc,10000)
      if (hexist(10003)) then
       print *,'Analysing a Monte Carlo ntuple'
       FromTracker = .false.
      else 
       print *,'Analysing a Tracking ntuple'
       FromTracker = .true.
      endif 
c write out for unsmearing
      open(unit=30
     +,name='/mnt/autofs/misc/b0urpc19.a/hbudd/mva/txt_file/ene_q2.dat'
     +,form='formatted',status='unknown')
C
C Declares appropriate ntuple blocks
C
      call DeclareNtupleBlocks(FromTracker)
C
C Process Files - up to the used as to what it does...
C
      call ProcessFile(FromTracker)

      call hrend('DATA')
      close(50)

      goto 10
100   continue

C
C Write out histograms
C
      call procEnd

      end
