c this file kluges range. It fills in the 
c values if they are not filled in.
c the values are only approximate
      real function beta(ener,m_tar) 
      real ener, m_tar
      if(ener.le.m_tar)then
        beta=0
      else 
        beta=sqrt(1-m_tar**2/ener**2)
      endif
      return
      end
c
      real function gama(ener,m_tar)
      real ener, m_tar
      if(ener.le.m_tar)then
        gama=999999999.0
      else 
        gama=ener/m_tar
      endif
      return
      end
c
      real function Tmax(ener,m_tar)
      real ener, m_tar
      real m_e/0.0005101/ ! in GeV
      tmax=2.0*m_e*(beta(ener,m_tar)*gama(ener,m_tar))**2
     +/(1+2.0*gama(ener,m_tar)*m_e/m_tar+(m_e/m_tar)**2)
      return
      end
c
      real function de_dx(ener,m_tar)
      real ener, m_tar
      real m_e/0.0005101/ ! in GeV
      real ion/0.000000078/ ! in GeV
      data con_carbon/0.0001529/ ! GeV/(gm/cm**2)    
      bet=beta(ener,m_tar)
      gamme=gama(ener,m_tar)
      if(ener.le.m_tar)then
        de_dx=0
      else
        de_dx=(con_carbon/bet**2)
     +   *(0.5*log(2.0*m_e*(gamme*bet)**2*Tmax(ener,m_tar)/ion**2)
     +      -bet**2)
      endif
      de_dx=abs(de_dx)
      return
      end
c
      real function rang(ener,m_tar)
#include "ntuple.inc"
      real ener, m_tar
      real del_ener/0.001/
      integer nmax
      rang=0.00001 
      nmax=ener/del_ener
      energy=ener
      do 10 i=1,nmax
        if(energy.gt.m_tar+10*del_ener)then 
          deedx = de_dx(energy,m_tar)
          if(deedx.gt.0)then
            rang = rang + del_ener/deedx
            energy = energy - abs(del_ener)
          endif
        endif
10    continue
      return
      end

      subroutine klug_range
#include "ntuple.inc"
c ********************** klug range *****************
c According to the plot from pdg plot, my program gets
c 80 gm/cm**2 = 0.28 GeV pmu, .3 emu , range = 84
c 150 gm/cm**2 = 0.42 GeV pmu, .43 emu, range = 155
c 240 gm/cm**2 = 0.58 GeV  pmu, .59 emu, range = 241
c 350 gm/cm**2 = 0.82 GeV, pmu .83 emu, range = 367
c calculate range from true energy
c
c ***********
c
      do irecon=1,nrecon
        itru=trk(irecon)
        ene=petrue(itru)
        part_mass2=ene**2-pxtrue(itru)**2-pytrue(itru)**2-pztrue(itru)**2
        part_mass=0
        if(iptrk(irecon).ne.22)then
          part_mass=sqrt(part_mass2)
          range(irecon)=rang(ene,part_mass)
        else
          range(irecon)=0.001 ! photon
        endif
      enddo
      return
      end
      subroutine wrt_range
#include "ntuple.inc"
      integer nwrt
      common /write_out/nwrt 
      write(6,788)
788      format('irecon iptrk  ene  '
     +   ,' mass   range   range.F tru_moth  vertex  escape shower')
      do irecon=1,nrecon
        itru=trk(irecon)
        ene=petrue(itru)
        part_mass2=ene**2-pxtrue(itru)**2-pytrue(itru)**2-pztrue(itru)**2
        part_mass=0
        rnge=0
        if(iptrk(irecon).ne.22)then
          part_mass=sqrt(part_mass2)
          rnge=rang(ene,part_mass)
        endif
         if(nev.le.nwrt)write(6,789)irecon,iptrk(irecon)
     +   ,ene,part_mass,range(irecon),rnge,ntmoth(trk(irecon))
     +   ,istartv(irecon),etrueex(itru),ishower(irecon)
789      format(i4,i7,f8.4,f7.4,f8.2,f8.2,i6,i8,f11.3,i4)
      enddo
      return
      end                                                                                

      subroutine fill_pid
c fill in some of the array which are not filled in
#include "ntuple.inc"
c
c ***********
c
      do irecon=1,nrecon
        itru=trk(irecon)
        ene=petrue(itru)
        pmom=pxtrue(itru)**2+pytrue(itru)**2+pztrue(itru)**2
        pmom=sqrt(pmom)
        edep(irecon)=pmom
        if(ishower(irecon).eq.0)then
          if(abs(iptrk(irecon)).le.1000)then
            pidchi2(1,irecon)=0.25+0.001*irecon
            pidchi2(2,irecon)=0.50
            pidchi2(3,irecon)=0.75-0.001*irecon
          else
            pidchi2(1,irecon)=0.75-0.001*irecon
            pidchi2(2,irecon)=0.50
            pidchi2(3,irecon)=0.25+0.001*irecon
          endif
        endif
      enddo
      return
      end
